;  matrix.asm    Com file TASM code
;  Matrix screen demo    80 x 25 line mode
;
        .MODEL  TINY                    ;05/09/02
        .386 
        .CODE 
        ORG     100H 
 
CHRATR  EQU     02H                     ;Character color 
FALATR  EQU     03H                     ;Falling character color 
;               ||_____________________  Foreground color 
;               |______________________  Background color 
NEWMSK  EQU     11111111B               ;New column random number mask 
 
COLVAR  STRUC 
        DB      132 DUP(0)              ;Character row 
SPCROW  DB      132 DUP(0)              ;Space row 
COLSTA  DB      132 DUP(00000000B)      ;Column status 
;                      |||||___________  Offset right 
;                      ||||____________  Offset left 
;                      |||_____________  Character done 
;                      ||______________  Space 
;                      |_______________  Character 
COLVAR  ENDS 
 
VARBLE  STRUC 
SEED    DD      ?                       ;Random seed 
CURLOC  DW      ?                       ;Entry cursor location 
VIDMOD  DB      ?                       ;Entry video mode 
ROWCT0  DB      ?                       ;Base 0 row count 
COLCNT  DW      ?                       ;Column count 
COLCT2  DW      ?                       ;2 * column count 
ROWCNT  DW      ?                       ;Row count 
VESMOD  DW      ?                       ;VESA mode 
CHRROW  COLVAR  <> 
VARBLE  ENDS 
 
START:  PUSH    CS 
        POP     DS                      ;Code segment to DS 
        PUSH    CS 
        POP     ES                      ;Code segment to ES 
        MOV     BP,offset VARBAS        ;Point to variable base 
        CALL    RNDMIZ                  ;Randomize pseudo-random sequence 
        MOV     AX,4F00H 
        MOV     DI,offset SCRBUF        ;Point to VESA buffer 
        INT     10H                     ;Get SVGA info 
        MOV     SI,DI                   ;VESA buffer pointer to SI 
        MOV     EAX,[SI]                ;Get signature 
        ;CMP     EAX,'ASEV'              ;VESA? 
        Jmp     SHORT NOVESA            ;No 
        LDS     SI,[SI+0EH]             ;Get mode block pointer 
        MOV     BX,10CH                 ;132 x 60 mode index 
        MOV     CX,132                  ;Column count 
        MOV     DX,60                   ;Row count 
        CALL    FNDMOD                  ;VESA supports 132 x 60 mode? 
        JZ      short MODFND            ;Yes 
        DEC     BX                      ;132 x 50 mode index (10BH) 
        MOV     DL,50                   ;Row count 
        CALL    FNDMOD                  ;VESA supports 132 x 50 mode? 
        JZ      short MODFND            ;Yes 
        DEC     BX                      ;132 x 43 mode index (10AH) 
        MOV     DL,43                   ;Row count 
        CALL    FNDMOD                  ;VESA supports 132 x 43 mode? 
        JZ      short MODFND            ;Yes 
        DEC     BX                      ;132 x 25 mode index (109H) 
        MOV     DL,25                   ;Row count 
        CALL    FNDMOD                  ;VESA supports 132 x 43 mode? 
        JZ      short MODFND            ;Yes 
        DEC     BX                      ;80 x 60 mode index (108H) 
        MOV     CX,80                   ;Column count 
        MOV     DL,60                   ;Row count 
        CALL    FNDMOD                  ;VESA supports 80 x 60 mode? 
        JZ      short MODFND            ;Yes 
NOVESA: XOR     BX,BX                   ;Null mode index 
        MOV     CX,80                   ;Column count 
        MOV     DX,25                   ;Row count 
MODFND: MOV     [BP+VESMOD],BX          ;Store VESA mode 
        MOV     [BP+COLCNT],CX          ;Store column count 
        ADD     CX,CX 
        MOV     [BP+COLCT2],CX          ;Store column count*2 
        MOV     [BP+ROWCNT],DX          ;Store row count 
        DEC     DX 
        MOV     [BP+ROWCT0],DL          ;Store base 0 row count 
        PUSH    CS 
        POP     DS                      ;Code segment to DS 
        PUSH    0B800H 
        POP     ES                      ;Screen segment to ES 
        MOV     AX,11 
        INT     33H                     ;Clear mouse motion counters 
        CALL    GETCUR                  ;Get cursor offset 
        MOV     [BP+CURLOC],AX          ;Store cursor offset 
        CALL    SAVSCR                  ;Save user's screen 
        MOV     AH,0FH 
        INT     10H                     ;Get video mode 
        MOV     [BP+VIDMOD],AL          ;Store video mode 
        MOV     AX,4F02H 
        MOV     BX,[BP+VESMOD]          ;Get VESA mode index 
        TEST    BX,BX                   ;Null video mode? 
        JZ      short DEFMOD            ;Yes 
        INT     10H                     ;Set VESA text mode 
DEFMOD: CALL    CUROFF                  ;Move cursor off screen 
        MOV     AX,CHRATR*256+' ' 
        MOV     CX,[BP+COLCNT]          ;Get column count 
        IMUL    CX,[BP+ROWCNT]          ;Calculate screen character count 
        XOR     DI,DI 
        REP     STOSW                   ;Clear largest possible screen 
UPDSCR: MOV     CX,[BP+COLCNT]          ;Get column count 
        XOR     DX,DX                   ;Clear column offset 
        LEA     SI,[BP+CHRROW]          ;Point to column status 
DOCOLM: MOV     BL,[SI+COLSTA]          ;Get column status 
        TEST    BL,BL                   ;Character or empty column? 
        JZ      short NEWCHR            ;Empty 
        JS      short ADJCHR            ;Character 
        TEST    BL,01000000B            ;Space column? 
        JZ      TSTDON                  ;No 
        CMP     byte ptr[SI+SPCROW],8   ;Spaces at least 8 rows down? 
        JB      ADJSPC                  ;No 
NEWCHR: CALL    RANDOM                  ;Get random number 
        TEST    AL,NEWMSK               ;Random number & mask = 0? 
        JNZ     short TTSSPC            ;No 
        CALL    RNDCHR                  ;Get random character 
        OR      BL,10000000B            ;Set "character" flag 
        MOV     AH,FALATR               ;Falling character attribute 
        MOV     DI,DX                   ;Column offset to DI 
        STOSW                           ;Store initial character 
TTSSPC: JMP     TSTSPC 
ADJCHR: MOV     AL,[SI]                 ;Get row 
        MOVZX   DI,AL                   ;Row to DI 
        IMUL    DI,[BP+COLCT2]          ;Calculate row offset 
        ADD     DI,DX                   ;Form screen pointer 
        CMP     AL,[BP+ROWCT0]          ;At or past bottom row? 
        PUSHF                           ;Save Z flag 
        JB      short ADJCH1            ;No 
        AND     BL,01111111B            ;Clear "character" flag 
        OR      BL,00100000B            ;Set "character done" flag 
        MOV     byte ptr[SI],0          ;Clear row 
ADJCH1: TEST    BL,00011000B            ;Offset left or right? 
        JZ      short NOTOFS            ;No 
        TEST    BL,00010000B            ;Offset left? 
        JZ      short OFSRHT            ;No 
        MOV     AX,ES:[DI-2]            ;Get offset left character 
        MOV     ES:byte ptr[DI-2],' '   ;Erase offset left character 
        JMP     short NXTCHR 
OFSRHT: MOV     AX,ES:[DI+2]            ;Get offset right character 
        MOV     ES:byte ptr[DI+2],' '   ;Erase offset right character 
        JMP     short NXTCHR 
NOTOFS: MOV     AH,CHRATR               ;Normal character color 
        CALL    RNDATR                  ;Invert "intense" bit if rand mod 32=0 
        MOV     ES:[DI+1],AH            ;Store character attribute 
NXTCHR: POPF                            ;In bottom row? 
        JAE     short NEWSPC            ;Yes 
        TEST    BL,00011000B            ;Offset left or right? 
        JZ      short NOTOF1            ;No 
        MOV     ES:[DI],AX              ;Store new character 
        AND     BL,11100111B            ;Clear "offset" flags 
        JMP     short NEWSPC 
NOTOF1: MOV     BH,[SI]                 ;Get row 
        CMP     BH,4                    ;< row 4? 
        JB      short DRPCHR            ;Yes 
        CMP     BH,[BP+ROWCT0]          ;last row? 
        JAE     short DRPCHR            ;Yes 
        PUSH    AX                      ;Save character & attribute 
        CALL    RANDOM                  ;Get random number 
        TEST    AL,00011111B            ;Mod 32 = 0? 
        POP     AX                      ;Restore character & attribute 
        JNZ     short DRPCHR            ;No 
        MOV     AL,ES:[DI]              ;Get current character 
        MOV     AH,FALATR xor 00001000B ;Falling char attr with "intense" bit 
        MOV     BH,' ' 
        TEST    DX,DX                   ;Column 0? 
        JZ      short TRYRHT            ;Yes 
        CMP     ES:[DI-2],BH            ;Space in column to left? 
        JNZ     short TRYRHT            ;No 
        PUSH    DI                      ;Save screen pointer 
        SUB     DI,[BP+COLCT2]          ;Adjust down 1 row 
        DEC     DI 
        DEC     DI                      ;Adjust left 1 column 
        CMP     ES:[DI],BH              ;Space in column to left 1 row up? 
        POP     DI                      ;Restore screen pointer 
        JNZ     short TRYRHT            ;No 
        OR      BL,00010000B            ;Set "offset left" flag 
        MOV     ES:[DI-2],AX            ;Store new character 
        JMP     short CLRCUR 
TRYRHT: CMP     DL,byte ptr[BP+ROWCNT]  ;Last column? 
        JZ      short DRPCHR            ;Yes 
        CMP     ES:[DI+2],BH            ;Space in column to right? 
        JNZ     short DRPCHR            ;No 
        PUSH    DI                      ;Save screen pointer 
        SUB     DI,[BP+COLCT2]          ;Adjust down 1 row 
        INC     DI 
        INC     DI                      ;Adjust left 1 column 
        CMP     ES:[DI],BH              ;Space in column to right 1 row up? 
        POP     DI                      ;Restore screen pointer 
        JNZ     short DRPCHR            ;No 
        OR      BL,00001000B            ;Set "offset right" flag 
        MOV     ES:[DI+2],AX            ;Store new character 
CLRCUR: MOV     ES:[DI],BH              ;Store space at current location 
        JMP     short NEWSPC 
DRPCHR: CALL    RNDCHR                  ;Get random character 
        MOV     AH,FALATR               ;Falling character color 
        CALL    RNDATR                  ;Invert "intense" bit if rand mod 32=0 
        PUSH    DI 
        ADD     DI,[BP+COLCT2]          ;Adjust to next row 
        MOV     ES:[DI],AX              ;Store new character 
        POP     DI 
        INC     byte ptr[SI]            ;Adjust row 
NEWSPC: TEST    BL,01000000B            ;Space? 
        JNZ     short ADJSPC            ;Yes 
TSTDON: TEST    BL,00100000B            ;Character done? 
        JNZ     short NWSPC1            ;Yes 
        CMP     byte ptr[SI],8          ;Character at least 8 rows down? 
        JB      short TSTSPC            ;No 
NWSPC1: CALL    RANDOM                  ;Get random number 
        TEST    AL,NEWMSK               ;Random number & mask = 0? 
        JNZ     short TSTSPC            ;No 
        MOV     byte ptr[SI+SPCROW],0   ;Clear space row 
        OR      BL,01000000B            ;Set "space" flag 
        AND     BL,11011111B            ;Clear "character done" flag 
        MOV     DI,DX                   ;Column offset to DI 
        JMP     short STOSPC 
TSTSPC: TEST    BL,01000000B            ;Space? 
        JZ      short NXTCOL            ;No 
ADJSPC: MOV     AL,[SI+SPCROW]          ;Get space row 
        CMP     AL,byte ptr[BP+ROWCNT]  ;Past bottom row? 
        JB      short AJSPC1            ;No 
        MOV     byte ptr[SI+SPCROW],0   ;Clear space row 
        AND     BL,10111111B            ;Clear "space" flag 
        JMP     short NXTCOL 
AJSPC1: INC     byte ptr[SI+SPCROW]     ;Adjust row 
        MOVZX   DI,AL                   ;Row to DI 
        INC     DI                      ;Adjust to next row 
        IMUL    DI,[BP+COLCT2]          ;Calculatate row offset 
        ADD     DI,DX                   ;Calculate screen pointer 
STOSPC: MOV     ES:byte ptr[DI],' '     ;Store space 
NXTCOL: MOV     [SI+COLSTA],BL          ;Update column status 
        INC     SI                      ;Adjust column status pointer 
        INC     DX 
        INC     DX                      ;Adjust column offset 
        DEC     CX                      ;More columns? 
        JNZ     DOCOLM                  ;Yes 
        CALL    GETTIK                  ;Get system tick count 
        XCHG    AX,BX                   ;Tick count to BX 
DLYTIK: CALL    GETTIK                  ;Get system tick count 
        SUB     AX,BX                   ;Calculate elapsed tick count 
        CMP     AX,3                    ;Time elapsed? 
        JB      short DLYTIK            ;No      
        XOR     CX,CX 
        XOR     DX,DX 
        MOV     AX,11 
        INT     33H                     ;Get mouse motion counters 
        TEST    CX,CX                   ;Horizontal count changed? 
        JNZ     short EXIT              ;Yes 
        TEST    DX,DX                   ;Vertical count changed? 
        JNZ     short EXIT              ;Yes 
        MOV     AH,1 
        INT     16H                     ;Key typed? 
        JZ      UPDSCR                  ;No 
        XOR     AH,AH 
        INT     16H                     ;Get key 
EXIT:   CMP     [BP+VESMOD],0           ;VESA mode set? 
        JZ      short NOVESM            ;No 
        MOV     AL,[BP+VIDMOD]          ;Get entry text mode 
        XOR     AH,AH 
        INT     10H                     ;Set entry text mode 
NOVESM: CALL    RESSCR                  ;Restore user's screen 
        MOV     DI,[BP+CURLOC]          ;Get original cursor offset 
        CALL    BIOCUR                  ;Set cursor 
TRMNAT: MOV     AH,4CH 
        INT     21H 
 
FNDMOD: PUSH    SI                      ;Save supported mode list pointer 
FNMODZ: LODSW                           ;Get a mode 
        CMP     AX,BX                   ;Requested mode? 
        JZ      short FMODOK            ;Yes 
        CMP     AX,-1                   ;EOB? 
        JNZ     SHORT FNMODZ            ;No 
        OR      AL,1                    ;"Not found"  (NZ) 
FMODOK: POP     SI                      ;Restore supported mode list pointer 
        RET 
 
RNDATR: PUSH    AX                      ;Save character & attribute 
        CALL    RANDOM                  ;Get random number 
        TEST    AL,00011111B            ;Mod 32 = 0? 
        POP     AX                      ;Restore character & attribute 
        JNZ     short RATRET            ;No 
        XOR     AH,00001000B            ;Invert "intense" bit 
RATRET: RET 
 
RNDCHR: CALL    RANDOM                  ;Get random number 
        CMP     AL,' '                  ;Space? 
        JZ      short RNDCHR            ;Yes 
        CMP     AL,0FFH                 ;Blank? 
        JZ      short RNDCHR            ;Yes 
        CMP     AL,0BH                  ;Weirdo 1st column character? 
        JB      short RNDCHR            ;Yes 
        CMP     AL,0B0H                 ;Possible line or box character? 
        JB      short RCHRET            ;No 
        CMP     AL,0B3H                 ;Line or box character? 
        JB      short RNDCHR            ;Yes 
        CMP     AL,0DBH                 ;Possible line or box character? 
        JB      short RCHRET            ;No 
        CMP     AL,0DFH                 ;Line or box character? 
        JBE     short RNDCHR            ;Yes 
RCHRET: RET 
 
RANDOM: MOV     EAX,[BP+SEED]           ;Get random seed 
        SHL     EAX,7                   ;Shift left 7 
        ADD     EAX,[BP+SEED]           ;Add old seed 
        ADD     EAX,361962E9H           ;Add random factor 
        MOV     [BP+SEED],EAX           ;Update random seed 
        ROL     EAX,16                  ;Return most random half in AX 
        RET 
 
RNDMIZ: MOV     AH,2AH 
        INT     21H                     ;Get date 
        PUSH    CX 
        PUSH    DX                      ;Save date 
        MOV     AH,2CH 
        INT     21H                     ;Get time 
        POP     AX 
        XOR     CX,AX 
        POP     AX 
        XOR     DX,AX                   ;Create random seed 
        MOV     word ptr[BP+SEED+2],CX 
        MOV     word ptr[BP+SEED],DX    ;Store random seed 
        RET 
 
GETTIK: PUSH    DS 
        PUSH    0 
        POP     DS                      ;RAM base segment to DS 
        MOV     AX,DS:word ptr[46CH]    ;Get system tick count 
        POP     DS 
        RET 
 
SAVSCR: PUSH    ES 
        POP     DS                      ;Screen segment to DS 
        PUSH    CS 
        POP     ES                      ;Code segment to ES 
        XOR     SI,SI                   ;Row 0, col 0 
        MOV     DI,offset SCRBUF        ;Point to screen save buffer 
        CALL    MOVSCR                  ;Copy screen to save buffer 
        PUSH    DS 
        POP     ES                      ;Screen segment to ES 
        PUSH    CS 
        POP     DS                      ;Code segment to DS 
        RET 
 
RESSCR: MOV     SI,offset SCRBUF        ;Point to screen save buffer 
        XOR     DI,DI                   ;Row 0, col 0 
MOVSCR: MOV     CX,80*25 
        REP     MOVSW                   ;Copy saved screen to screen 
        RET 
 
;Move cursor off screen 
CUROFF: MOV     DI,60*264+0*2           ;Row 60, column 0  (off screen) 
;set cursor to DI 
SETCUR: PUSH    AX 
        PUSH    DX 
        MOV     AL,0FH                  ;Cursor address low register index 
        MOV     DX,3D4H                 ;Point to CRTC address register 
        OUT     DX,AL                   ;Select cursor address low register 
        INC     DX                      ;Adjust to CRTC data register 
        MOV     AX,DI                   ;Screen address to AX 
        SHR     AX,1                    ;FORM BYTE ADDRESS 
        OUT     DX,AL                   ;Latch low cursor address to CRTC 
        DEC     DX 
        MOV     AL,0EH                  ;Cursor address high register index 
        OUT     DX,AL                   ;Select cursor address low register 
        INC     DX                      ;ADJUST TO CRTC data register 
        MOV     AL,AH                   ;MS screen address to AL 
        OUT     DX,AL                   ;Latch low cursor address to CRTC 
        POP     DX 
        POP     AX 
        RET 
 
GETCUR: PUSH    DX 
        MOV     AL,0EH                  ;Cursor address high register index 
        MOV     DX,3D4H                 ;Point to CRTC address register 
        OUT     DX,AL                   ;Select cursor address high register 
        INC     DX                      ;Adjust to CRTC data register 
        IN      AL,DX                   ;Get high cursor address from CRTC 
        MOV     AH,AL                   ;High cursor address to AH 
        DEC     DX                      ;Adjust to CRTC address register 
        MOV     AL,0FH                  ;Cursor address low register index 
        OUT     DX,AL                   ;Select cursor address low register 
        INC     DX                      ;Adjust to CRTC data register 
        IN      AL,DX                   ;Get low cursor address from CRTC 
        ADD     AX,AX                   ;Form word address 
        POP     DX 
        RET 
 
BIOCUR: XCHG    AX,DI                   ;Screen pointer to AX 
        SHR     AX,1                    ;Form column 
        MOV     CH,80 
        DIV     CH                      ;Calculate row & column 
        XCHG    AL,AH                   ;Row to AH, column to AL 
        XCHG    AX,DX                   ;Row to DH, column to DL 
        MOV     AH,2 
        JMP     short VIDBIO 
CONOUT: MOV     AH,14 
VIDBIO: PUSH    BX 
        XOR     BH,BH 
        INT     10H                     ;Send character to console 
        POP     BX 
        RET 
 
VARBAS  VARBLE  <>                      ;Variables 
SCRBUF: END     START 
